require_relative '../config/configuration'
require_relative 'actions'
require_relative 'params'
require 'rest-client'
require 'json'
require 'uri'
require 'securerandom'
require 'nokogiri'
require "net/https"
require 'openssl'


class GPRestClient

  def initialize()
  end


  def createAccount
    params = Params.new
    params.with_apiLogin(Configuration::API_LOGIN)
    params.with_apiTransKey(Configuration::API_TRANSKEY)
    params.with_providerId(Configuration::PROVIDER_ID)
    params.with_transactionId(SecureRandom.base64)
    params.with_prodId(Configuration::PROD_ID)

    return self.GpDoPost(Actions::CREATE_ACCOUNT, params)
  end


  #  API Request  #
  def GpDoPost(action,payload)
    service_url = "#{Configuration::API_REQUEST_URI}#{action}"
    obj = nil
    begin
      uri = URI.parse(service_url)
      http = Net::HTTP.new(uri.host, uri.port)
      http.use_ssl = true
      http.cert = OpenSSL::X509::Certificate.new(File.read("#{Configuration::PATH_TO_PEM}"))
      http.key = OpenSSL::PKey::RSA.new(File.read("#{Configuration::PATH_TO_PEM}"))

      request = Net::HTTP::Post.new(uri.request_uri)
      request['response-content-type'] = 'json'
      request['content-type'] = 'json'
      body = payload.get_params
      request.body = body.to_json

      request.set_form_data(payload.get_params)
      response = http.request(request)

      puts response
      puts response.body
      obj = response
    rescue StandardError => e
      puts e.message
    end
    return obj
  end

end